<template>
  <q-dialog
    ref="dialog"
    @hide="$emit('hide')"
  >
    <q-card class="q-dialog-plugin">
      <q-card-section>
        <div
          class="text-h5 text-weight-bolder text-grey-9 q-pb-sm"
          v-text="'Tema'"
        />
      </q-card-section>

      <q-card-section>
        <q-form class="row q-gutter-y-sm">
          <q-input
            v-model="form.name"
            class="col-12"
            label="Nome"
            color="primary"
            bottom-slots
            outlined
            dense
            :error="$v.form.name.$error"
          >
            <template v-slot:error>
              <div
                v-for="(message, index) in errorMessages($v.form.name)"
                :key="index"
                v-text="message"
              />
            </template>
          </q-input>

          <q-uploader
            class="col-12"
            text-color="dark"
            accept="application/pdf"
            label="Material de Apoio"
            color="white"
            hide-upload-btn
            no-thumbnails
            bordered
            flat
            @added="upload"
          />

          <q-input
            v-model="form.material"
            class="col-12"
            label="Material de Apoio"
            color="primary"
            bottom-slots
            outlined
            disable
            dense
            :error="$v.form.material.$error"
          >
            <template v-slot:error>
              <div
                v-for="(message, index) in errorMessages($v.form.material)"
                :key="index"
                v-text="message"
              />
            </template>
          </q-input>

          <q-uploader
            class="col-12"
            text-color="dark"
            accept="image/*"
            label="Imagem"
            color="white"
            hide-upload-btn
            no-thumbnails
            bordered
            flat
            @added="upload"
          />

          <q-input
            v-model="form.image"
            class="col-12"
            label="Imagem"
            color="primary"
            bottom-slots
            outlined
            disable
            dense
            :error="$v.form.image.$error"
          >
            <template v-slot:error>
              <div
                v-for="(message, index) in errorMessages($v.form.image)"
                :key="index"
                v-text="message"
              />
            </template>
          </q-input>
        </q-form>
      </q-card-section>

      <q-card-actions align="right">
        <q-btn
          class="q-mr-sm q-mb-sm"
          color="primary"
          label="OK"
          @click="save"
        />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script>
import { ErrorMessagesMixin } from '../../mixin/error-messages'
import { required } from 'vuelidate/lib/validators'
import { uid } from 'quasar'
import path from 'path'

export default {
  name: 'FormTopic',
  mixins: [ErrorMessagesMixin],
  props: {
    value: {
      type: Object,
      required: true
    }
  },
  data () {
    return {
      form: this.value
    }
  },
  validations: {
    form: {
      name: {
        required
      },
      material: {
        required
      },
      image: {
        required
      }
    }
  },
  methods: {
    show () {
      this.$refs.dialog.show()
    },
    hide () {
      this.$refs.dialog.hide()
    },
    async save () {
      this.$v.form.$touch()

      if (this.$v.form.$error) {
        return undefined
      }

      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: this.form.id ? 'PATCH' : 'POST',
          url: `/Topics/${this.form.id || ''}`,
          data: JSON.parse(JSON.stringify(this.form))
        }

        await this.$axios(axiosConfig)

        this.axiosSuccess('Salvo com sucesso')
      } catch (err) {
        this.axiosCatch(err)
      } finally {
        this.$q.loading.hide()
        this.$emit('ok')
        this.hide()
      }
    },
    async upload (files) {
      const fileType = files[0].type.includes('image') ? 'image' : 'material'
      const newExt = path.extname(files[0].name)
      const oldExt = path.extname(this.form[fileType]) || newExt
      const fileName = this.form[fileType].split('.')[0] || uid()

      try {
        const axiosConfig = {
          method: 'POST',
          url: '/Storages/topics/upload',
          headers: { 'Content-Type': 'multipart/form-data' },
          data: new FormData()
        }

        axiosConfig.data.append('file', files[0], fileName + newExt)

        await this.$axios(axiosConfig)

        this.form[fileType] = fileName + newExt

        if (oldExt !== newExt) {
          await this.delete(fileName + oldExt)
        }
      } catch (err) {
        this.axiosCatch(err)
      }
    },
    async delete (file) {
      try {
        const axiosConfig = {
          method: 'DELETE',
          url: `/Storages/topics/files/${file}`
        }

        await this.$axios(axiosConfig)
      } catch (err) {
        this.axiosCatch(err)
      }
    }
  }
}
</script>
